require_dependency "rechn_mgm_web/application_controller"

# This controller will be extended by other engines which need to change the global behavior (like authentication).
# IMPORTANT: All Controllers needs to be sub-classed from this controller!
module RechnMgmWeb
    class AuthenticatedController < ApplicationController
        def get_token
            create_token
        end

        def get_token_for_membership
            membership   = RechnMgmUserArea::MemberShip.find(authenticated_params[:id])
            current_user.current_membership_id = membership.id

            create_token

            render "get_token"
        end

        private
        def create_token
            @token, payload = Warden::JWTAuth::UserEncoder.new.call(current_user, :user, nil)
            @expire = payload["exp"]
        end

        def authenticated_params
            params.permit(:id)
        end
    end
end
