#encoding: utf-8
require_dependency "rechn_mgm_web/authenticated_controller"
require 'refile/rails/attachment_helper.rb'
require 'securerandom'

module RechnMgmWeb
    class DocumentsController < AuthenticatedController
        before_action :set_document, only: [:show, :edit, :update, :destroy, :validate]
        #before_action :check_authentication, only: :show
        #before_action  :get_all_documents, only: [:index]
        before_action :create_token, only: [:index]

        # GET /documents
        def index
            # Get current user token
            fail "not authenticated" if current_user.nil?
        end

        private
        # Use callbacks to share common setup or constraints between actions.
        def set_document
            @document = Nukleus::Document.find(params[:id])
        end

        # Only allow a trusted parameter "white list" through.
        def document_params
            params.require(:document).permit(:document_file, :document_id)
        end

        def check_authentication
            # Make sure that old stored URL's from browser history will not work.
            fail RechnMgmWeb::ApplicationController::NotAuthorised if current_user.id != @document.user_id
        end

        private
        def normalized_file_name(name)
            name.gsub( /[^a-zA-Z0-9_\.]/, '_')
        end
    end
end
