module RechnMgmWeb
    class DocumentBroadcastJob < ApplicationJob
        def perform(document)
            document_hash   = JSON.parse(document)
            current_user_id = document_hash["userId"]
            prev_user_id    = document_hash["prevUserId"]
            state           = document_hash["state"]

            owning_user = DeviseAuthentication::User.find(current_user_id)
            user_ids_to_tell_about = owning_user.all_buchhalter_user_ids_of_all_my_organisations

            case state
            when Nukleus::Document.document_states.index(:DOCUMENT_STATE_IMPORTED)
                # Tell all Buchhalter of of all organisations the owning user belongs to...
            when Nukleus::Document.document_states.index(:DOCUMENT_STATE_ASSIGNED), Nukleus::Document.document_states.index(:DOCUMENT_STATE_RETURNED)
                user_ids_to_tell_about.push current_user_id
                if prev_user_id.present?
                    user_ids_to_tell_about.push prev_user_id
                end
            else
                Rails.logger.error("Unknown state cannot be handeled: #{state}")
            end

            user_ids_to_tell_about.each do |user_id|
                ActionCable.server.broadcast "document_channel_#{user_id}", document
            end
        end
    end
end
